#ifndef _PLUMPCONFIG_H
#define _PLUMPCONFIG_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#if defined(TARGET_GENRE_UNIX)
	#include <signal.h>
	#include <errno.h>
	#include <sys/types.h>
	#include <fcntl.h>
	#include <unistd.h>
#elif defined(TARGET_GENRE_WINDOWS)
	#include <windows.h>
#endif

#define REGISTER_STRUCT_TYPE_USER_REGS_STRUCT 0x0001
#define REGISTER_STRUCT_TYPE_REG              0x0002

#if defined(OS_LINUX)
	#include <asm/user.h>     // struct user_regs_struct

	extern int ptrace (int request, int pid, ...);
#elif defined(OS_FREEBSD)    // struct reg
	#include <sys/param.h>
	#include <sys/types.h>
	#include <machine/reg.h>
	#include <sys/user.h>

	#if defined(MEDIUM_HAS_PTRACE)
		#include <sys/ptrace.h>
	#endif
#elif defined(OS_WIN32)

#elif defined(OS_SUNOS)

#else
	#error "Unknown registers!"
#endif


#include "plump.h"
#include "mediums.h"

// Internal methods

int plump_registersTranslate(unsigned long type, void *reg, plumpreg_t *want, unsigned long numWanted, unsigned long read);

#endif
